<template>
	<a-card :bordered="false">
		<s-table
			ref="tableRef"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('remindCycleAdd')">
						<template #icon><plus-outlined /></template>
						新增
					</a-button>
					<xn-batch-delete
						v-if="hasPerm('remindCycleBatchDelete')"
						:selectedRowKeys="selectedRowKeys"
						@batchDelete="deleteBatchRemindCycle"
					/>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('remindCycleEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['remindCycleEdit', 'remindCycleDelete'], 'and')" />
						<a-popconfirm title="确定要删除吗？" @confirm="deleteRemindCycle(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('remindCycleDelete')">删除</a-button>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="tableRef.refresh()" />
</template>

<script setup name="remindcycle">
	import { cloneDeep } from 'lodash-es'
	import Form from './form.vue'
	import remindCycleApi from '@/api/basic.info/remindCycleApi'
	const tableRef = ref()
	const formRef = ref()
	const toolConfig = { refresh: true, height: true, columnSetting: true, striped: false }
	const columns = [
		{
			title: '报送周期；周一：1.....周日：7；',
			dataIndex: 'dayOfWeek'
		},
		{
			title: '报送开始时间',
			dataIndex: 'startTime'
		},
		{
			title: '报送结束时间',
			dataIndex: 'endTime'
		},
		{
			title: '提前提醒；提前小时数；',
			dataIndex: 'advanceHour'
		},
	]
	// 操作栏通过权限判断是否显示
	if (hasPerm(['remindCycleEdit', 'remindCycleDelete'])) {
		columns.push({
			title: '操作',
			dataIndex: 'action',
			align: 'center',
			width: 150
		})
	}
	const selectedRowKeys = ref([])
	// 列表选择配置
	const options = {
		// columns数字类型字段加入 needTotal: true 可以勾选自动算账
		alert: {
			show: true,
			clear: () => {
				selectedRowKeys.value = ref([])
			}
		},
		rowSelection: {
			onChange: (selectedRowKey, selectedRows) => {
				selectedRowKeys.value = selectedRowKey
			}
		}
	}
	const loadData = (parameter) => {
		return remindCycleApi.remindCyclePage(parameter).then((data) => {
			return data
		})
	}
	// 重置
	const reset = () => {
		searchFormRef.value.resetFields()
		tableRef.value.refresh(true)
	}
	// 删除
	const deleteRemindCycle = (record) => {
		let params = [
			{
				id: record.id
			}
		]
		remindCycleApi.remindCycleDelete(params).then(() => {
			tableRef.value.refresh(true)
		})
	}
	// 批量删除
	const deleteBatchRemindCycle = (params) => {
		remindCycleApi.remindCycleDelete(params).then(() => {
			tableRef.value.clearRefreshSelected()
		})
	}
</script>
